#include <stdio.h>
#include <nnwork.h>

#include "brain.h"

static nnwork *Brain = NULL;
static int Treenattu = 0;
 
void BrainTrain(float *in, float *out, float err, float rate)
{
	Brain->train(in, out, err, rate);
	Treenattu = 1;
}

void UseBrain(float *in, float *out)
{
	Brain->run(in, out);
}

void InitBrain(int insize, int layersize, int outsize)
{
	if(!Brain)
	{
		Brain = new nnwork(insize, layersize, outsize);
		Brain->load(brainfn);
		Treenattu = 0;
	}	
}

void DoneBrain(void)
{
	if(Brain)
	{
		if(Treenattu)
		{
			printf("Saving the brains to %s\n", brainfn);
			Brain->save(brainfn);
		}
		delete Brain;
		Brain = NULL;
	}
}
